classification
Title: BufferedRWpair doesn't clear weakrefs
Type: crash Stage: resolved
Components: Versions: Python 3.5, Python 3.3, Python 3.4, Python 2.7
process
Status: closed Resolution: fixed
Dependencies: Superseder:
Assigned To: Nosy List: Arfrever, benjamin.peterson, pitrou, pkt, python-dev, stutzbach
Priority: normal Keywords:

Created on 2014-09-29 20:59 by pkt, last changed 2014-10-15 12:07 by pkt. This issue is now closed.

Files
File name Uploaded Description Edit
poc_brwpair_weakref.py pkt, 2014-09-29 20:59
Messages (5)
msg227835 - (view) Author: paul (pkt) Date: 2014-09-29 20:59
# static void
# bufferedrwpair_dealloc(rwpair *self)
# {
#     _PyObject_GC_UNTRACK(self);
#     Py_CLEAR(self->reader);
#     Py_CLEAR(self->writer);
#     Py_CLEAR(self->dict);
#     Py_TYPE(self)->tp_free((PyObject *) self);
# }
# 
# Weakrefs to this object contain stale pointer after BufferedRWPair is freed.
msg227866 - (view) Author: Roundup Robot (python-dev) Date: 2014-09-30 02:49
New changeset 9b4673d7b046 by Benjamin Peterson in branch '2.7':
clear BufferedRWPair weakrefs on deallocation (closes #22517)
https://hg.python.org/cpython/rev/9b4673d7b046

New changeset e834b32f0422 by Benjamin Peterson in branch '3.3':
clear BufferedRWPair weakrefs on deallocation (closes #22517)
https://hg.python.org/cpython/rev/e834b32f0422

New changeset e54da75100f6 by Benjamin Peterson in branch '3.4':
merge 3.3 (#22517)
https://hg.python.org/cpython/rev/e54da75100f6

New changeset a2add97e28b9 by Benjamin Peterson in branch 'default':
merge 3.4 (#22517)
https://hg.python.org/cpython/rev/a2add97e28b9
msg227905 - (view) Author: Roundup Robot (python-dev) Date: 2014-09-30 12:59
New changeset 4fa5239624b8 by Georg Brandl in branch '3.2':
Issue #22517: When a io.BufferedRWPair object is deallocated, clear its
https://hg.python.org/cpython/rev/4fa5239624b8
msg227922 - (view) Author: Antoine Pitrou (pitrou) * (Python committer) Date: 2014-09-30 13:59
It's an actual crash, AFAIK.
msg229438 - (view) Author: paul (pkt) Date: 2014-10-15 12:07
Why did the type changed from security to crash?
History
Date User Action Args
2014-10-15 12:07:23pktsetmessages: + msg229438
2014-09-30 13:59:38pitrousettype: security -> crash
messages: + msg227922
2014-09-30 13:41:47hayposettype: crash -> security
2014-09-30 12:59:27python-devsetmessages: + msg227905
2014-09-30 06:37:15Arfreversetversions: + Python 3.3, Python 3.5
2014-09-30 02:49:43python-devsetstatus: open -> closed

nosy: + python-dev
messages: + msg227866

resolution: fixed
stage: resolved
2014-09-29 23:20:57Arfreversetnosy: + Arfrever
2014-09-29 21:13:52serhiy.storchakasetnosy: + pitrou, benjamin.peterson, stutzbach

versions: + Python 2.7
2014-09-29 20:59:02pktcreate